# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 20010 Akretion LDTA (<http://www.akretion.com>).
#    @author Raphaël Valyi
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from tools.translate import _
from osv import fields, osv


class sale_order_line(osv.osv):
    _inherit = "sale.order.line"
    
    _columns = {
        'phase_id': fields.many2one('project.phase', 'Phase'),
        'resource_allocation_id': fields.many2one('project.resource.allocation', 'Resource Allocation'),
     }
sale_order_line()


class sale_order(osv.osv):
    _inherit = "sale.order"
    
    def get_order_service_lines_to_invoice(self, cr, uid, ids, context=None):
        lines = super(sale_order, self).get_order_service_lines_to_invoice(cr, uid, ids, context)
        for order in self.browse(cr, uid, ids):
            for line in order.order_line:
                if line.resource_allocation_id and line.resource_allocation_id.phase_id.progress > 0.01 and abs(line.resource_allocation_id.net_amount_resource_invoiceable) > 0.01:#TODO and more to invoice
                    lines.append([line, line.resource_allocation_id.net_amount_resource_invoiceable, line.product_id.id])
        return lines
    
    def action_cancel(self, cr, uid, ids, context=None):
        res = super(sale_order, self).action_cancel(cr, uid, ids, context)
        alloc_obj = self.pool.get('project.resource.allocation')
        for order in self.browse(cr, uid, ids):
            for order_line in order.order_line:
                if order_line.phase_id:
                    alloc_obj.write(cr, uid, [allocation.id for allocation in order_line.phase_id.resource_ids], {'sale_id': False})                        
        return res
        
sale_order()
